]>
Commit | Line | Data |
---|---|---|
1 | #!/bin/sh -- # no runable script, just for vi | |
2 | ||
3 | EXIT_CODE=0 | |
4 | ||
5 | # we all like colorful messages | |
6 | if [ "$MSGCOLOR" != 'NO' ]; then | |
7 | if ! expr match "$(readlink -f /proc/$$/fd/1)" '/dev/pts/[0-9]\+' > /dev/null; then | |
8 | export MSGCOLOR='NO' | |
9 | fi | |
10 | fi | |
11 | ||
12 | ||
13 | if [ "$MSGCOLOR" != 'NO' ]; then | |
14 | CERROR="\033[1;31m" # red | |
15 | CWARNING="\033[1;33m" # yellow | |
16 | CMSG="\033[1;32m" # green | |
17 | CINFO="\033[1;96m" # light blue | |
18 | CDEBUG="\033[1;94m" # blue | |
19 | CNORMAL="\033[0;39m" # default system console color | |
20 | CDONE="\033[1;32m" # green | |
21 | CPASS="\033[1;32m" # green | |
22 | CFAIL="\033[1;31m" # red | |
23 | CCMD="\033[1;35m" # pink | |
24 | fi | |
25 | ||
26 | msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; } | |
27 | msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; } | |
28 | msgmsg() { echo "${CMSG}$1${CNORMAL}"; } | |
29 | msginfo() { echo "${CINFO}I: $1${CNORMAL}"; } | |
30 | msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}"; } | |
31 | msgdone() { echo "${CDONE}DONE${CNORMAL}"; } | |
32 | msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; } | |
33 | msgnmsg() { echo -n "${CMSG}$1${CNORMAL}"; } | |
34 | msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}"; } | |
35 | msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}"; } | |
36 | msgtest() { | |
37 | while [ -n "$1" ]; do | |
38 | echo -n "${CINFO}$1${CCMD} " | |
39 | echo -n "$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} " | |
40 | shift | |
41 | if [ -n "$1" ]; then shift; else break; fi | |
42 | done | |
43 | echo -n "…${CNORMAL} " | |
44 | } | |
45 | msgpass() { echo "${CPASS}PASS${CNORMAL}"; } | |
46 | msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; } | |
47 | msgfail() { | |
48 | if [ $# -gt 0 ]; then echo "${CFAIL}FAIL: $*${CNORMAL}" >&2; | |
49 | else echo "${CFAIL}FAIL${CNORMAL}" >&2; fi | |
50 | EXIT_CODE=$((EXIT_CODE+1)); | |
51 | } | |
52 | ||
53 | # enable / disable Debugging | |
54 | MSGLEVEL=${MSGLEVEL:-3} | |
55 | if [ $MSGLEVEL -le 0 ]; then | |
56 | msgdie() { true; } | |
57 | fi | |
58 | if [ $MSGLEVEL -le 1 ]; then | |
59 | msgwarn() { true; } | |
60 | msgnwarn() { true; } | |
61 | fi | |
62 | if [ $MSGLEVEL -le 2 ]; then | |
63 | msgmsg() { true; } | |
64 | msgnmsg() { true; } | |
65 | msgtest() { true; } | |
66 | msgpass() { echo -n " ${CPASS}P${CNORMAL}"; } | |
67 | msgskip() { echo -n " ${CWARNING}S${CNORMAL}" >&2; } | |
68 | if [ -n "$CFAIL" ]; then | |
69 | msgfail() { echo -n " ${CFAIL}FAIL${CNORMAL}" >&2; EXIT_CODE=$((EXIT_CODE+1)); } | |
70 | else | |
71 | msgfail() { echo -n " ###FAILED###" >&2; EXIT_CODE=$((EXIT_CODE+1)); } | |
72 | fi | |
73 | fi | |
74 | if [ $MSGLEVEL -le 3 ]; then | |
75 | msginfo() { true; } | |
76 | msgninfo() { true; } | |
77 | fi | |
78 | if [ $MSGLEVEL -le 4 ]; then | |
79 | msgdebug() { true; } | |
80 | msgndebug() { true; } | |
81 | fi | |
82 | msgdone() { | |
83 | if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] || | |
84 | [ "$1" = "info" -a $MSGLEVEL -le 3 ] || | |
85 | [ "$1" = "msg" -a $MSGLEVEL -le 2 ] || | |
86 | [ "$1" = "warn" -a $MSGLEVEL -le 1 ] || | |
87 | [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then | |
88 | true; | |
89 | else | |
90 | echo "${CDONE}DONE${CNORMAL}"; | |
91 | fi | |
92 | } | |
93 | getaptconfig() { | |
94 | if [ -f ./aptconfig.conf ]; then | |
95 | echo "./aptconfig.conf" | |
96 | elif [ -f ../aptconfig.conf ]; then | |
97 | echo "../aptconfig.conf" | |
98 | fi | |
99 | } | |
100 | runapt() { | |
101 | msgdebug "Executing: ${CCMD}$*${CDEBUG} " | |
102 | local CMD="$1" | |
103 | shift | |
104 | case $CMD in | |
105 | sh|aptitude|*/*) ;; | |
106 | *) CMD="${BUILDDIRECTORY}/$CMD";; | |
107 | esac | |
108 | MALLOC_PERTURB_=21 MALLOC_CHECK_=2 APT_CONFIG="$(getaptconfig)" LD_LIBRARY_PATH=${BUILDDIRECTORY} $CMD "$@" | |
109 | } | |
110 | aptconfig() { runapt apt-config "$@"; } | |
111 | aptcache() { runapt apt-cache "$@"; } | |
112 | aptcdrom() { runapt apt-cdrom "$@"; } | |
113 | aptget() { runapt apt-get "$@"; } | |
114 | aptftparchive() { runapt apt-ftparchive "$@"; } | |
115 | aptkey() { runapt apt-key "$@"; } | |
116 | aptmark() { runapt apt-mark "$@"; } | |
117 | apt() { runapt apt "$@"; } | |
118 | apthelper() { runapt "${APTHELPERBINDIR}/apt-helper" "$@"; } | |
119 | aptwebserver() { runapt "${APTWEBSERVERBINDIR}/aptwebserver" "$@"; } | |
120 | aptitude() { runapt aptitude "$@"; } | |
121 | aptextracttemplates() { runapt apt-extracttemplates "$@"; } | |
122 | ||
123 | dpkg() { | |
124 | command dpkg --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log "$@" | |
125 | } | |
126 | dpkgcheckbuilddeps() { | |
127 | command dpkg-checkbuilddeps --admindir=${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg "$@" | |
128 | } | |
129 | gdb() { | |
130 | echo "gdb: run »$*«" | |
131 | APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${LIBRARYPATH} command gdb ${BUILDDIRECTORY}/$1 --args "$@" | |
132 | } | |
133 | gpg() { | |
134 | # see apt-key for the whole trickery. Setup is done in setupenvironment | |
135 | command gpg --ignore-time-conflict --no-options --no-default-keyring \ | |
136 | --homedir "${TMPWORKINGDIRECTORY}/gnupghome" \ | |
137 | --no-auto-check-trustdb --trust-model always \ | |
138 | "$@" | |
139 | } | |
140 | ||
141 | exitwithstatus() { | |
142 | # error if we about to overflow, but ... | |
143 | # "255 failures ought to be enough for everybody" | |
144 | if [ $EXIT_CODE -gt 255 ]; then | |
145 | msgdie "Total failure count $EXIT_CODE too big" | |
146 | fi | |
147 | exit $((EXIT_CODE <= 255 ? EXIT_CODE : 255)); | |
148 | } | |
149 | ||
150 | shellsetedetector() { | |
151 | local exit_status=$? | |
152 | if [ "$exit_status" != '0' ]; then | |
153 | echo >&2 "${CERROR}E: Looks like the testcases ended prematurely with exitcode: ${exit_status}${CNORMAL}" | |
154 | if [ "$EXIT_CODE" = '0' ]; then | |
155 | EXIT_CODE="$exit_status" | |
156 | fi | |
157 | fi | |
158 | } | |
159 | ||
160 | addtrap() { | |
161 | if [ "$1" = 'prefix' ]; then | |
162 | CURRENTTRAP="$2 $CURRENTTRAP" | |
163 | else | |
164 | CURRENTTRAP="$CURRENTTRAP $1" | |
165 | fi | |
166 | trap "shellsetedetector; $CURRENTTRAP exitwithstatus;" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM | |
167 | } | |
168 | ||
169 | setupenvironment() { | |
170 | TMPWORKINGDIRECTORY=$(mktemp -d) | |
171 | TESTDIRECTORY=$(readlink -f $(dirname $0)) | |
172 | msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… " | |
173 | ||
174 | # allow overriding the default BUILDDIR location | |
175 | BUILDDIRECTORY=${APT_INTEGRATION_TESTS_BUILD_DIR:-"${TESTDIRECTORY}/../../build/bin"} | |
176 | LIBRARYPATH=${APT_INTEGRATION_TESTS_LIBRARY_PATH:-"${BUILDDIRECTORY}"} | |
177 | METHODSDIR=${APT_INTEGRATION_TESTS_METHODS_DIR:-"${BUILDDIRECTORY}/methods"} | |
178 | APTHELPERBINDIR=${APT_INTEGRATION_TESTS_LIBEXEC_DIR:-"${BUILDDIRECTORY}"} | |
179 | APTWEBSERVERBINDIR=${APT_INTEGRATION_TESTS_WEBSERVER_BIN_DIR:-"${BUILDDIRECTORY}"} | |
180 | test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first" | |
181 | # ----- | |
182 | ||
183 | addtrap "cd /; rm -rf $TMPWORKINGDIRECTORY;" | |
184 | cd $TMPWORKINGDIRECTORY | |
185 | mkdir rootdir aptarchive keys | |
186 | cd rootdir | |
187 | mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d | |
188 | mkdir -p var/cache var/lib/apt var/log tmp | |
189 | mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers | |
190 | touch var/lib/dpkg/available | |
191 | mkdir -p usr/lib/apt | |
192 | ln -s ${METHODSDIR} usr/lib/apt/methods | |
193 | # use the autoremove from the BUILDDIRECTORY if its there, otherwise | |
194 | # system | |
195 | if [ -e ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove ]; then | |
196 | ln -s ${BUILDDIRECTORY}/../../debian/apt.conf.autoremove etc/apt/apt.conf.d/01autoremove | |
197 | else | |
198 | ln -s /etc/apt/apt.conf.d/01autoremove etc/apt/apt.conf.d/01autoremove | |
199 | fi | |
200 | cd .. | |
201 | local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/') | |
202 | if [ -f "${TESTDIRECTORY}/${PACKAGESFILE}" ]; then | |
203 | cp "${TESTDIRECTORY}/${PACKAGESFILE}" aptarchive/Packages | |
204 | fi | |
205 | local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/') | |
206 | if [ -f "${TESTDIRECTORY}/${SOURCESSFILE}" ]; then | |
207 | cp "${TESTDIRECTORY}/${SOURCESSFILE}" aptarchive/Sources | |
208 | fi | |
209 | cp $(find $TESTDIRECTORY -name '*.pub' -o -name '*.sec') keys/ | |
210 | ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg | |
211 | echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf | |
212 | echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf | |
213 | echo "Debug::NoLocking \"true\";" >> aptconfig.conf | |
214 | echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf | |
215 | echo "Dir::Bin::Methods \"${METHODSDIR}\";" >> aptconfig.conf | |
216 | echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf | |
217 | echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf | |
218 | echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf | |
219 | echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf | |
220 | echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf | |
221 | if ! command dpkg --assert-multi-arch >/dev/null 2>&1; then | |
222 | echo "DPKG::options:: \"--force-architecture\";" >> aptconfig.conf # Added to test multiarch before dpkg is ready for it… | |
223 | fi | |
224 | echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf | |
225 | echo 'quiet::NoUpdate "true";' >> aptconfig.conf | |
226 | echo "Acquire::https::CaInfo \"${TESTDIR}/apt.pem\";" > rootdir/etc/apt/apt.conf.d/99https | |
227 | echo "Apt::Cmd::Disable-Script-Warning \"1\";" > rootdir/etc/apt/apt.conf.d/apt-binary | |
228 | configcompression '.' 'gz' #'bz2' 'lzma' 'xz' | |
229 | ||
230 | # gpg needs a trustdb to function, but it can't be invalid (not even empty) | |
231 | # see also apt-key where this trickery comes from: | |
232 | local TRUSTDBDIR="${TMPWORKINGDIRECTORY}/gnupghome" | |
233 | mkdir "$TRUSTDBDIR" | |
234 | chmod 700 "$TRUSTDBDIR" | |
235 | # We also don't use a secret keyring, of course, but gpg panics and | |
236 | # implodes if there isn't one available - and writeable for imports | |
237 | local SECRETKEYRING="${TRUSTDBDIR}/secring.gpg" | |
238 | touch $SECRETKEYRING | |
239 | # now create the trustdb with an (empty) dummy keyring | |
240 | # newer gpg versions are fine without it, but play it safe for now | |
241 | gpg --quiet --check-trustdb --secret-keyring $SECRETKEYRING --keyring $SECRETKEYRING >/dev/null 2>&1 | |
242 | ||
243 | # cleanup the environment a bit | |
244 | export PATH="${PATH}:/usr/local/sbin:/usr/sbin:/sbin" | |
245 | export LC_ALL=C.UTF-8 | |
246 | unset LANGUAGE APT_CONFIG | |
247 | unset GREP_OPTIONS DEB_BUILD_PROFILES | |
248 | ||
249 | msgdone "info" | |
250 | } | |
251 | ||
252 | getarchitecture() { | |
253 | if [ "$1" = "native" -o -z "$1" ]; then | |
254 | eval `aptconfig shell ARCH APT::Architecture` | |
255 | if [ -n "$ARCH" ]; then | |
256 | echo $ARCH | |
257 | else | |
258 | dpkg --print-architecture | |
259 | fi | |
260 | else | |
261 | echo $1 | |
262 | fi | |
263 | } | |
264 | ||
265 | getarchitectures() { | |
266 | echo "$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')" | |
267 | } | |
268 | ||
269 | getarchitecturesfromcommalist() { | |
270 | echo "$1" | sed -e 's#,#\n#g' | sed -e "s/^native\$/$(getarchitecture 'native')/" | |
271 | } | |
272 | ||
273 | configarchitecture() { | |
274 | { | |
275 | echo "APT::Architecture \"$(getarchitecture $1)\";" | |
276 | while [ -n "$1" ]; do | |
277 | echo "APT::Architectures:: \"$(getarchitecture $1)\";" | |
278 | shift | |
279 | done | |
280 | } >rootdir/etc/apt/apt.conf.d/01multiarch.conf | |
281 | configdpkg | |
282 | } | |
283 | ||
284 | configdpkg() { | |
285 | if [ ! -e rootdir/var/lib/dpkg/status ]; then | |
286 | local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/') | |
287 | if [ -f "${TESTDIRECTORY}/${STATUSFILE}" ]; then | |
288 | cp "${TESTDIRECTORY}/${STATUSFILE}" rootdir/var/lib/dpkg/status | |
289 | else | |
290 | echo -n > rootdir/var/lib/dpkg/status | |
291 | fi | |
292 | fi | |
293 | rm -f rootdir/etc/apt/apt.conf.d/00foreigndpkg | |
294 | if command dpkg --assert-multi-arch >/dev/null 2>&1 ; then | |
295 | local ARCHS="$(getarchitectures)" | |
296 | if echo "$ARCHS" | grep -E -q '[^ ]+ [^ ]+'; then | |
297 | DPKGARCH="$(dpkg --print-architecture)" | |
298 | for ARCH in ${ARCHS}; do | |
299 | if [ "${ARCH}" != "${DPKGARCH}" ]; then | |
300 | if ! dpkg --add-architecture ${ARCH} >/dev/null 2>&1; then | |
301 | # old-style used e.g. in Ubuntu-P – and as it seems travis | |
302 | echo "DPKG::options:: \"--foreign-architecture\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg | |
303 | echo "DPKG::options:: \"${ARCH}\";" >> rootdir/etc/apt/apt.conf.d/00foreigndpkg | |
304 | fi | |
305 | fi | |
306 | done | |
307 | if [ "0" = "$(dpkg -l dpkg 2> /dev/null | grep '^i' | wc -l)" ]; then | |
308 | # dpkg doesn't really check the version as long as it is fully installed, | |
309 | # but just to be sure we choose one above the required version | |
310 | insertinstalledpackage 'dpkg' "all" '1.16.2+fake' | |
311 | fi | |
312 | fi | |
313 | fi | |
314 | } | |
315 | ||
316 | configcompression() { | |
317 | while [ -n "$1" ]; do | |
318 | case "$1" in | |
319 | '.') echo ".\t.\tcat";; | |
320 | 'gz') echo "gzip\tgz\tgzip";; | |
321 | 'bz2') echo "bzip2\tbz2\tbzip2";; | |
322 | 'lzma') echo "lzma\tlzma\txz --format=lzma";; | |
323 | 'xz') echo "xz\txz\txz";; | |
324 | *) echo "$1\t$1\t$1";; | |
325 | esac | |
326 | shift | |
327 | done > ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | |
328 | } | |
329 | ||
330 | setupsimplenativepackage() { | |
331 | local NAME="$1" | |
332 | local ARCH="$2" | |
333 | local VERSION="$3" | |
334 | local RELEASE="${4:-unstable}" | |
335 | local DEPENDENCIES="$5" | |
336 | local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE} | |
337 | If you find such a package installed on your system, | |
338 | something went horribly wrong! They are autogenerated | |
339 | und used only by testcases and surf no other propose…"}" | |
340 | ||
341 | local SECTION="${7:-others}" | |
342 | local DISTSECTION | |
343 | if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then | |
344 | DISTSECTION="main" | |
345 | else | |
346 | DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)" | |
347 | fi | |
348 | local BUILDDIR=incoming/${NAME}-${VERSION} | |
349 | mkdir -p ${BUILDDIR}/debian/source | |
350 | cd ${BUILDDIR} | |
351 | echo "* most suckless software product ever" > FEATURES | |
352 | test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright | |
353 | test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low | |
354 | ||
355 | * Initial release | |
356 | ||
357 | -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog | |
358 | test -e debian/control || echo "Source: $NAME | |
359 | Section: $SECTION | |
360 | Priority: optional | |
361 | Maintainer: Joe Sixpack <joe@example.org> | |
362 | Build-Depends: debhelper (>= 7) | |
363 | Standards-Version: 3.9.1 | |
364 | ||
365 | Package: $NAME" > debian/control | |
366 | if [ "$ARCH" = 'all' ]; then | |
367 | echo "Architecture: all" >> debian/control | |
368 | else | |
369 | echo "Architecture: any" >> debian/control | |
370 | fi | |
371 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control | |
372 | echo "Description: $DESCRIPTION" >> debian/control | |
373 | ||
374 | test -e debian/compat || echo "7" > debian/compat | |
375 | test -e debian/source/format || echo "3.0 (native)" > debian/source/format | |
376 | test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules | |
377 | cd - > /dev/null | |
378 | } | |
379 | ||
380 | buildsimplenativepackage() { | |
381 | local NAME="$1" | |
382 | local ARCH="$2" | |
383 | local VERSION="$3" | |
384 | local RELEASE="${4:-unstable}" | |
385 | local DEPENDENCIES="$5" | |
386 | local DESCRIPTION="${6:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE} | |
387 | If you find such a package installed on your system, | |
388 | something went horribly wrong! They are autogenerated | |
389 | und used only by testcases and surf no other propose…"}" | |
390 | ||
391 | local SECTION="${7:-others}" | |
392 | local PRIORITY="${8:-optional}" | |
393 | local FILE_TREE="$9" | |
394 | local COMPRESS_TYPE="${10:-gzip}" | |
395 | local DISTSECTION | |
396 | if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then | |
397 | DISTSECTION="main" | |
398 | else | |
399 | DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)" | |
400 | fi | |
401 | local BUILDDIR=${TMPWORKINGDIRECTORY}/incoming/${NAME}-${VERSION} | |
402 | ||
403 | msgninfo "Build package ${NAME} in ${VERSION} for ${RELEASE} in ${DISTSECTION}… " | |
404 | mkdir -p $BUILDDIR/debian/source | |
405 | echo "* most suckless software product ever" > ${BUILDDIR}/FEATURES | |
406 | echo "#!/bin/sh | |
407 | echo '$NAME says \"Hello!\"'" > ${BUILDDIR}/${NAME} | |
408 | ||
409 | echo "Copyleft by Joe Sixpack $(date +%Y)" > ${BUILDDIR}/debian/copyright | |
410 | echo "$NAME ($VERSION) $RELEASE; urgency=low | |
411 | ||
412 | * Initial release | |
413 | ||
414 | -- Joe Sixpack <joe@example.org> $(date -R)" > ${BUILDDIR}/debian/changelog | |
415 | echo "Source: $NAME | |
416 | Section: $SECTION | |
417 | Priority: $PRIORITY | |
418 | Maintainer: Joe Sixpack <joe@example.org> | |
419 | Standards-Version: 3.9.3" > ${BUILDDIR}/debian/control | |
420 | local BUILDDEPS="$(echo "$DEPENDENCIES" | grep '^Build-')" | |
421 | test -z "$BUILDDEPS" || echo "$BUILDDEPS" >> ${BUILDDIR}/debian/control | |
422 | echo " | |
423 | Package: $NAME" >> ${BUILDDIR}/debian/control | |
424 | ||
425 | if [ "$ARCH" = 'all' ]; then | |
426 | echo "Architecture: all" >> ${BUILDDIR}/debian/control | |
427 | else | |
428 | echo "Architecture: any" >> ${BUILDDIR}/debian/control | |
429 | fi | |
430 | local DEPS="$(echo "$DEPENDENCIES" | grep -v '^Build-')" | |
431 | test -z "$DEPS" || echo "$DEPS" >> ${BUILDDIR}/debian/control | |
432 | echo "Description: $DESCRIPTION" >> ${BUILDDIR}/debian/control | |
433 | ||
434 | echo '3.0 (native)' > ${BUILDDIR}/debian/source/format | |
435 | (cd ${BUILDDIR}/..; dpkg-source -b ${NAME}-${VERSION} 2>&1) | sed -n 's#^dpkg-source: info: building [^ ]\+ in ##p' \ | |
436 | | while read SRC; do | |
437 | echo "pool/${SRC}" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.srclist | |
438 | # if expr match "${SRC}" '.*\.dsc' >/dev/null 2>&1; then | |
439 | # gpg --yes --secret-keyring ./keys/joesixpack.sec \ | |
440 | # --keyring ./keys/joesixpack.pub --default-key 'Joe Sixpack' \ | |
441 | # --clearsign -o "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC" | |
442 | # mv "${BUILDDIR}/../${SRC}.sign" "${BUILDDIR}/../$SRC" | |
443 | # fi | |
444 | done | |
445 | ||
446 | for arch in $(getarchitecturesfromcommalist "$ARCH"); do | |
447 | rm -rf ${BUILDDIR}/debian/tmp | |
448 | mkdir -p ${BUILDDIR}/debian/tmp/DEBIAN ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} ${BUILDDIR}/debian/tmp/usr/bin | |
449 | cp ${BUILDDIR}/debian/copyright ${BUILDDIR}/debian/changelog ${BUILDDIR}/FEATURES ${BUILDDIR}/debian/tmp/usr/share/doc/${NAME} | |
450 | cp ${BUILDDIR}/${NAME} ${BUILDDIR}/debian/tmp/usr/bin/${NAME}-${arch} | |
451 | if [ -n "$FILE_TREE" ]; then | |
452 | cp -ar "$FILE_TREE" ${BUILDDIR}/debian/tmp | |
453 | fi | |
454 | ||
455 | (cd ${BUILDDIR}; dpkg-gencontrol -DArchitecture=$arch) | |
456 | (cd ${BUILDDIR}/debian/tmp; md5sum $(find usr/ -type f) > DEBIAN/md5sums) | |
457 | local LOG="${BUILDDIR}/../${NAME}_${VERSION}_${arch}.dpkg-deb.log" | |
458 | # ensure the right permissions as dpkg-deb ensists | |
459 | chmod 755 ${BUILDDIR}/debian/tmp/DEBIAN | |
460 | if ! dpkg-deb -Z${COMPRESS_TYPE} --build ${BUILDDIR}/debian/tmp ${BUILDDIR}/.. >$LOG 2>&1; then | |
461 | cat $LOG | |
462 | false | |
463 | fi | |
464 | rm $LOG | |
465 | echo "pool/${NAME}_${VERSION}_${arch}.deb" >> ${BUILDDIR}/../${RELEASE}.${DISTSECTION}.pkglist | |
466 | done | |
467 | ||
468 | mkdir -p ${BUILDDIR}/../${NAME}_${VERSION} | |
469 | cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}/ | |
470 | cp ${BUILDDIR}/debian/changelog ${BUILDDIR}/../${NAME}_${VERSION}.changelog | |
471 | rm -rf "${BUILDDIR}" | |
472 | msgdone "info" | |
473 | } | |
474 | ||
475 | buildpackage() { | |
476 | local BUILDDIR=$1 | |
477 | local RELEASE=$2 | |
478 | local SECTION=$3 | |
479 | local ARCH=$(getarchitecture $4) | |
480 | local PKGNAME="$(echo "$BUILDDIR" | grep -o '[^/]*$')" | |
481 | local BUILDLOG="$(readlink -f "${BUILDDIR}/../${PKGNAME}_${RELEASE}_${SECTION}.dpkg-bp.log")" | |
482 | msgninfo "Build package ${PKGNAME} for ${RELEASE} in ${SECTION}… " | |
483 | cd $BUILDDIR | |
484 | if [ "$ARCH" = "all" ]; then | |
485 | ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)" | |
486 | fi | |
487 | if ! dpkg-buildpackage -uc -us -a$ARCH >$BUILDLOG 2>&1 ; then | |
488 | cat $BUILDLOG | |
489 | false | |
490 | fi | |
491 | local PKGS="$(grep '^dpkg-deb: building package' $BUILDLOG | cut -d'/' -f 2 | sed -e "s#'\.##")" | |
492 | local SRCS="$(grep '^dpkg-source: info: building' $BUILDLOG | grep -o '[a-z0-9._+~-]*$')" | |
493 | cd - > /dev/null | |
494 | for PKG in $PKGS; do | |
495 | echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist | |
496 | done | |
497 | for SRC in $SRCS; do | |
498 | echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist | |
499 | done | |
500 | msgdone "info" | |
501 | } | |
502 | ||
503 | buildaptarchive() { | |
504 | if [ -d incoming ]; then | |
505 | buildaptarchivefromincoming "$@" | |
506 | else | |
507 | buildaptarchivefromfiles "$@" | |
508 | fi | |
509 | } | |
510 | ||
511 | createaptftparchiveconfig() { | |
512 | local COMPRESSORS="$(cut -d' ' -f 1 ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | tr '\n' ' ')" | |
513 | COMPRESSORS="${COMPRESSORS%* }" | |
514 | local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')" | |
515 | if [ -z "$ARCHS" ]; then | |
516 | # the pool is empty, so we will operate on faked packages - let us use the configured archs | |
517 | ARCHS="$(getarchitectures)" | |
518 | fi | |
519 | echo -n 'Dir { | |
520 | ArchiveDir "' >> ftparchive.conf | |
521 | echo -n $(readlink -f .) >> ftparchive.conf | |
522 | echo -n '"; | |
523 | CacheDir "' >> ftparchive.conf | |
524 | echo -n $(readlink -f ..) >> ftparchive.conf | |
525 | echo -n '"; | |
526 | FileListDir "' >> ftparchive.conf | |
527 | echo -n $(readlink -f pool/) >> ftparchive.conf | |
528 | echo -n '"; | |
529 | }; | |
530 | Default { | |
531 | Packages::Compress "'"$COMPRESSORS"'"; | |
532 | Sources::Compress "'"$COMPRESSORS"'"; | |
533 | Contents::Compress "'"$COMPRESSORS"'"; | |
534 | Translation::Compress "'"$COMPRESSORS"'"; | |
535 | LongDescription "false"; | |
536 | }; | |
537 | TreeDefault { | |
538 | Directory "pool/"; | |
539 | SrcDirectory "pool/"; | |
540 | }; | |
541 | APT { | |
542 | FTPArchive { | |
543 | Release { | |
544 | Origin "joesixpack"; | |
545 | Label "apttestcases"; | |
546 | Suite "unstable"; | |
547 | Description "repository with dummy packages"; | |
548 | Architectures "' >> ftparchive.conf | |
549 | echo -n "$ARCHS" >> ftparchive.conf | |
550 | echo 'source"; | |
551 | }; | |
552 | }; | |
553 | };' >> ftparchive.conf | |
554 | for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do | |
555 | echo -n 'tree "dists/' >> ftparchive.conf | |
556 | echo -n "$DIST" >> ftparchive.conf | |
557 | echo -n '" { | |
558 | Architectures "' >> ftparchive.conf | |
559 | echo -n "$ARCHS" >> ftparchive.conf | |
560 | echo -n 'source"; | |
561 | FileList "' >> ftparchive.conf | |
562 | echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf | |
563 | echo -n '"; | |
564 | SourceFileList "' >> ftparchive.conf | |
565 | echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf | |
566 | echo -n '"; | |
567 | Sections "' >> ftparchive.conf | |
568 | echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf | |
569 | echo '"; | |
570 | };' >> ftparchive.conf | |
571 | done | |
572 | } | |
573 | ||
574 | buildaptftparchivedirectorystructure() { | |
575 | local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')" | |
576 | for DIST in $DISTS; do | |
577 | local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)" | |
578 | for SECTION in $SECTIONS; do | |
579 | local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')" | |
580 | for ARCH in $ARCHS; do | |
581 | mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH} | |
582 | done | |
583 | mkdir -p dists/${DIST}/${SECTION}/source | |
584 | mkdir -p dists/${DIST}/${SECTION}/i18n | |
585 | done | |
586 | done | |
587 | } | |
588 | ||
589 | insertpackage() { | |
590 | local RELEASE="$1" | |
591 | local NAME="$2" | |
592 | local ARCH="$3" | |
593 | local VERSION="$4" | |
594 | local DEPENDENCIES="$5" | |
595 | local PRIORITY="${6:-optional}" | |
596 | local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/${RELEASE} | |
597 | If you find such a package installed on your system, | |
598 | something went horribly wrong! They are autogenerated | |
599 | und used only by testcases and surf no other propose…"}" | |
600 | local ARCHS="" | |
601 | for arch in $(getarchitecturesfromcommalist "$ARCH"); do | |
602 | if [ "$arch" = 'all' -o "$arch" = 'none' ]; then | |
603 | ARCHS="$(getarchitectures)" | |
604 | else | |
605 | ARCHS="$arch" | |
606 | fi | |
607 | for BUILDARCH in $ARCHS; do | |
608 | local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}" | |
609 | mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source | |
610 | touch aptarchive/dists/${RELEASE}/main/source/Sources | |
611 | local FILE="${PPATH}/Packages" | |
612 | echo "Package: $NAME | |
613 | Priority: $PRIORITY | |
614 | Section: other | |
615 | Installed-Size: 42 | |
616 | Maintainer: Joe Sixpack <joe@example.org>" >> $FILE | |
617 | test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE | |
618 | echo "Version: $VERSION | |
619 | Filename: pool/main/${NAME}/${NAME}_${VERSION}_${arch}.deb" >> $FILE | |
620 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE | |
621 | echo "Description: $DESCRIPTION" >> $FILE | |
622 | echo >> $FILE | |
623 | done | |
624 | done | |
625 | } | |
626 | ||
627 | insertsource() { | |
628 | local RELEASE="$1" | |
629 | local NAME="$2" | |
630 | local ARCH="$3" | |
631 | local VERSION="$4" | |
632 | local DEPENDENCIES="$5" | |
633 | local ARCHS="" | |
634 | local SPATH="aptarchive/dists/${RELEASE}/main/source" | |
635 | mkdir -p $SPATH | |
636 | local FILE="${SPATH}/Sources" | |
637 | echo "Package: $NAME | |
638 | Binary: $NAME | |
639 | Version: $VERSION | |
640 | Maintainer: Joe Sixpack <joe@example.org> | |
641 | Architecture: $ARCH" >> $FILE | |
642 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE | |
643 | echo "Files: | |
644 | d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.dsc | |
645 | d41d8cd98f00b204e9800998ecf8427e 0 ${NAME}_${VERSION}.tar.gz | |
646 | " >> $FILE | |
647 | } | |
648 | ||
649 | insertinstalledpackage() { | |
650 | local NAME="$1" | |
651 | local ARCH="$2" | |
652 | local VERSION="$3" | |
653 | local DEPENDENCIES="$4" | |
654 | local PRIORITY="${5:-optional}" | |
655 | local STATUS="${6:-install ok installed}" | |
656 | local DESCRIPTION="${7:-"an autogenerated dummy ${NAME}=${VERSION}/installed | |
657 | If you find such a package installed on your system, | |
658 | something went horribly wrong! They are autogenerated | |
659 | und used only by testcases and surf no other propose…"}" | |
660 | ||
661 | local FILE='rootdir/var/lib/dpkg/status' | |
662 | local INFO='rootdir/var/lib/dpkg/info' | |
663 | for arch in $(getarchitecturesfromcommalist "$ARCH"); do | |
664 | echo "Package: $NAME | |
665 | Status: $STATUS | |
666 | Priority: $PRIORITY | |
667 | Section: other | |
668 | Installed-Size: 42 | |
669 | Maintainer: Joe Sixpack <joe@example.org> | |
670 | Version: $VERSION" >> $FILE | |
671 | test "$arch" = 'none' || echo "Architecture: $arch" >> $FILE | |
672 | test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE | |
673 | echo "Description: $DESCRIPTION" >> $FILE | |
674 | echo >> $FILE | |
675 | if [ "$(dpkg-query -W --showformat='${Multi-Arch}')" = 'same' ]; then | |
676 | echo -n > ${INFO}/${NAME}:${arch}.list | |
677 | else | |
678 | echo -n > ${INFO}/${NAME}.list | |
679 | fi | |
680 | done | |
681 | } | |
682 | ||
683 | ||
684 | buildaptarchivefromincoming() { | |
685 | msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…" | |
686 | cd aptarchive | |
687 | [ -e pool ] || ln -s ../incoming pool | |
688 | [ -e ftparchive.conf ] || createaptftparchiveconfig | |
689 | [ -e dists ] || buildaptftparchivedirectorystructure | |
690 | msgninfo "\tGenerate Packages, Sources and Contents files… " | |
691 | aptftparchive -qq generate ftparchive.conf | |
692 | cd - > /dev/null | |
693 | msgdone "info" | |
694 | generatereleasefiles | |
695 | } | |
696 | ||
697 | buildaptarchivefromfiles() { | |
698 | msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…" | |
699 | find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do | |
700 | msgninfo "\t${line} file… " | |
701 | compressfile "$line" "$1" | |
702 | msgdone "info" | |
703 | done | |
704 | generatereleasefiles "$@" | |
705 | } | |
706 | ||
707 | compressfile() { | |
708 | cat ${TMPWORKINGDIRECTORY}/rootdir/etc/testcase-compressor.conf | while read compressor extension command; do | |
709 | if [ "$compressor" = '.' ]; then | |
710 | if [ -n "$2" ]; then | |
711 | touch -d "$2" "$1" | |
712 | fi | |
713 | continue | |
714 | fi | |
715 | cat "$1" | $command > "${1}.${extension}" | |
716 | if [ -n "$2" ]; then | |
717 | touch -d "$2" "${1}.${extension}" | |
718 | fi | |
719 | done | |
720 | } | |
721 | ||
722 | # can be overridden by testcases for their pleasure | |
723 | getcodenamefromsuite() { | |
724 | case "$1" in | |
725 | unstable) echo 'sid';; | |
726 | *) echo -n "$1";; | |
727 | esac | |
728 | } | |
729 | getreleaseversionfromsuite() { true; } | |
730 | getlabelfromsuite() { true; } | |
731 | ||
732 | generatereleasefiles() { | |
733 | # $1 is the Date header and $2 is the ValidUntil header to be set | |
734 | # both should be given in notation date/touch can understand | |
735 | msgninfo "\tGenerate Release files… " | |
736 | if [ -e aptarchive/dists ]; then | |
737 | for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do | |
738 | local SUITE="$(echo "$dir" | cut -d'/' -f 4)" | |
739 | local CODENAME="$(getcodenamefromsuite $SUITE)" | |
740 | local VERSION="$(getreleaseversionfromsuite $SUITE)" | |
741 | local LABEL="$(getlabelfromsuite $SUITE)" | |
742 | if [ -n "$VERSION" ]; then | |
743 | VERSION="-o APT::FTPArchive::Release::Version=${VERSION}" | |
744 | fi | |
745 | if [ -n "$LABEL" ]; then | |
746 | LABEL="-o APT::FTPArchive::Release::Label=${LABEL}" | |
747 | fi | |
748 | aptftparchive -qq release $dir \ | |
749 | -o APT::FTPArchive::Release::Suite="${SUITE}" \ | |
750 | -o APT::FTPArchive::Release::Codename="${CODENAME}" \ | |
751 | ${LABEL} \ | |
752 | ${VERSION} \ | |
753 | | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference | |
754 | if [ "$SUITE" = "experimental" -o "$SUITE" = "experimental2" ]; then | |
755 | sed -i '/^Date: / a\ | |
756 | NotAutomatic: yes' $dir/Release | |
757 | fi | |
758 | if [ -n "$1" -a "$1" != "now" ]; then | |
759 | sed -i "s/^Date: .*$/Date: $(date -d "$1" '+%a, %d %b %Y %H:%M:%S %Z')/" $dir/Release | |
760 | fi | |
761 | if [ -n "$2" ]; then | |
762 | sed -i "/^Date: / a\ | |
763 | Valid-Until: $(date -d "$2" '+%a, %d %b %Y %H:%M:%S %Z')" $dir/Release | |
764 | fi | |
765 | done | |
766 | else | |
767 | aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference | |
768 | fi | |
769 | if [ -n "$1" -a "$1" != "now" ]; then | |
770 | for release in $(find ./aptarchive -name 'Release'); do | |
771 | touch -d "$1" $release | |
772 | done | |
773 | fi | |
774 | msgdone "info" | |
775 | } | |
776 | ||
777 | setupdistsaptarchive() { | |
778 | local APTARCHIVE=$(readlink -f ./aptarchive) | |
779 | rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list | |
780 | rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list | |
781 | for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do | |
782 | SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ') | |
783 | msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… " | |
784 | echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list | |
785 | echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list | |
786 | msgdone "info" | |
787 | done | |
788 | } | |
789 | ||
790 | setupflataptarchive() { | |
791 | local APTARCHIVE=$(readlink -f ./aptarchive) | |
792 | if [ -f ${APTARCHIVE}/Packages ]; then | |
793 | msgninfo "\tadd deb sources.list line… " | |
794 | echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list | |
795 | msgdone "info" | |
796 | else | |
797 | rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list | |
798 | fi | |
799 | if [ -f ${APTARCHIVE}/Sources ]; then | |
800 | msgninfo "\tadd deb-src sources.list line… " | |
801 | echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list | |
802 | msgdone "info" | |
803 | else | |
804 | rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list | |
805 | fi | |
806 | } | |
807 | ||
808 | setupaptarchive() { | |
809 | buildaptarchive | |
810 | if [ -e aptarchive/dists ]; then | |
811 | setupdistsaptarchive | |
812 | else | |
813 | setupflataptarchive | |
814 | fi | |
815 | signreleasefiles | |
816 | if [ "$1" != '--no-update' ]; then | |
817 | msgninfo "\tSync APT's cache with the archive… " | |
818 | aptget update -qq | |
819 | msgdone "info" | |
820 | fi | |
821 | } | |
822 | ||
823 | signreleasefiles() { | |
824 | local SIGNER="${1:-Joe Sixpack}" | |
825 | local GPG="gpg --batch --yes" | |
826 | msgninfo "\tSign archive with $SIGNER key… " | |
827 | local REXKEY='keys/rexexpired' | |
828 | local SECEXPIREBAK="${REXKEY}.sec.bak" | |
829 | local PUBEXPIREBAK="${REXKEY}.pub.bak" | |
830 | if [ "${SIGNER}" = 'Rex Expired' ]; then | |
831 | # the key is expired, so gpg doesn't allow to sign with and the --faked-system-time | |
832 | # option doesn't exist anymore (and using faketime would add a new obscure dependency) | |
833 | # therefore we 'temporary' make the key not expired and restore a backup after signing | |
834 | cp ${REXKEY}.sec $SECEXPIREBAK | |
835 | cp ${REXKEY}.pub $PUBEXPIREBAK | |
836 | local SECUNEXPIRED="${REXKEY}.sec.unexpired" | |
837 | local PUBUNEXPIRED="${REXKEY}.pub.unexpired" | |
838 | if [ -f "$SECUNEXPIRED" ] && [ -f "$PUBUNEXPIRED" ]; then | |
839 | cp $SECUNEXPIRED ${REXKEY}.sec | |
840 | cp $PUBUNEXPIRED ${REXKEY}.pub | |
841 | else | |
842 | printf "expire\n1w\nsave\n" | $GPG --keyring ${REXKEY}.pub --secret-keyring ${REXKEY}.sec --command-fd 0 --edit-key "${SIGNER}" >/dev/null 2>&1 || true | |
843 | cp ${REXKEY}.sec $SECUNEXPIRED | |
844 | cp ${REXKEY}.pub $PUBUNEXPIRED | |
845 | fi | |
846 | fi | |
847 | for KEY in $(find keys/ -name '*.sec'); do | |
848 | GPG="$GPG --secret-keyring $KEY" | |
849 | done | |
850 | for KEY in $(find keys/ -name '*.pub'); do | |
851 | GPG="$GPG --keyring $KEY" | |
852 | done | |
853 | for RELEASE in $(find aptarchive/ -name Release); do | |
854 | $GPG --default-key "$SIGNER" --armor --detach-sign --sign --output ${RELEASE}.gpg ${RELEASE} | |
855 | local INRELEASE="$(echo "${RELEASE}" | sed 's#/Release$#/InRelease#')" | |
856 | $GPG --default-key "$SIGNER" --clearsign --output $INRELEASE $RELEASE | |
857 | # we might have set a specific date for the Release file, so copy it | |
858 | touch -d "$(stat --format "%y" ${RELEASE})" ${RELEASE}.gpg ${INRELEASE} | |
859 | done | |
860 | if [ -f "$SECEXPIREBAK" ] && [ -f "$PUBEXPIREBAK" ]; then | |
861 | mv -f $SECEXPIREBAK ${REXKEY}.sec | |
862 | mv -f $PUBEXPIREBAK ${REXKEY}.pub | |
863 | fi | |
864 | msgdone "info" | |
865 | } | |
866 | ||
867 | webserverconfig() { | |
868 | msgtest "Set webserver config option '${1}' to" "$2" | |
869 | local DOWNLOG='rootdir/tmp/download-testfile.log' | |
870 | local STATUS='rootdir/tmp/webserverconfig.status' | |
871 | rm -f "$STATUS" "$DOWNLOG" | |
872 | if downloadfile "http://localhost:8080/_config/set/${1}/${2}" "$STATUS" > "$DOWNLOG"; then | |
873 | msgpass | |
874 | else | |
875 | cat "$DOWNLOG" "$STATUS" | |
876 | msgfail | |
877 | fi | |
878 | testwebserverlaststatuscode '200' | |
879 | } | |
880 | ||
881 | rewritesourceslist() { | |
882 | local APTARCHIVE="file://$(readlink -f "${TMPWORKINGDIRECTORY}/aptarchive")" | |
883 | for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do | |
884 | sed -i $LIST -e "s#$APTARCHIVE#${1}#" -e "s#http://localhost:8080/#${1}#" -e "s#http://localhost:4433/#${1}#" | |
885 | done | |
886 | } | |
887 | ||
888 | # wait for up to 10s for a pid file to appear to avoid possible race | |
889 | # when a helper is started and dosn't write the PID quick enough | |
890 | waitforpidfile() { | |
891 | local PIDFILE="$1" | |
892 | for i in $(seq 10); do | |
893 | if test -s "$PIDFILE"; then | |
894 | return 0 | |
895 | fi | |
896 | sleep 1 | |
897 | done | |
898 | msgdie "waiting for $PIDFILE failed" | |
899 | return 1 | |
900 | } | |
901 | ||
902 | changetowebserver() { | |
903 | if [ "$1" != '--no-rewrite' ]; then | |
904 | rewritesourceslist 'http://localhost:8080/' | |
905 | else | |
906 | shift | |
907 | fi | |
908 | if test -x ${APTWEBSERVERBINDIR}/aptwebserver; then | |
909 | cd aptarchive | |
910 | local LOG="webserver.log" | |
911 | if ! aptwebserver -o aptwebserver::fork=1 "$@" >$LOG 2>&1 ; then | |
912 | cat $LOG | |
913 | false | |
914 | fi | |
915 | waitforpidfile aptwebserver.pid | |
916 | local PID="$(cat aptwebserver.pid)" | |
917 | if [ -z "$PID" ]; then | |
918 | msgdie 'Could not fork aptwebserver successfully' | |
919 | fi | |
920 | addtrap "kill $PID;" | |
921 | cd - > /dev/null | |
922 | else | |
923 | msgdie 'You have to build aptwerbserver or install a webserver' | |
924 | fi | |
925 | } | |
926 | ||
927 | changetohttpswebserver() { | |
928 | if ! which stunnel4 >/dev/null; then | |
929 | msgdie 'You need to install stunnel4 for https testcases' | |
930 | fi | |
931 | if [ ! -e "${TMPWORKINGDIRECTORY}/aptarchive/aptwebserver.pid" ]; then | |
932 | changetowebserver --no-rewrite "$@" | |
933 | fi | |
934 | echo "pid = ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid | |
935 | cert = ${TESTDIRECTORY}/apt.pem | |
936 | output = /dev/null | |
937 | ||
938 | [https] | |
939 | accept = 4433 | |
940 | connect = 8080 | |
941 | " > ${TMPWORKINGDIRECTORY}/stunnel.conf | |
942 | stunnel4 "${TMPWORKINGDIRECTORY}/stunnel.conf" | |
943 | waitforpidfile "${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid" | |
944 | local PID="$(cat ${TMPWORKINGDIRECTORY}/aptarchive/stunnel.pid)" | |
945 | if [ -z "$PID" ]; then | |
946 | msgdie 'Could not fork stunnel4 successfully' | |
947 | fi | |
948 | addtrap 'prefix' "kill ${PID};" | |
949 | rewritesourceslist 'https://localhost:4433/' | |
950 | } | |
951 | ||
952 | changetocdrom() { | |
953 | mkdir -p rootdir/media/cdrom/.disk | |
954 | local CD="$(readlink -f rootdir/media/cdrom)" | |
955 | echo "acquire::cdrom::mount \"${CD}\"; | |
956 | acquire::cdrom::${CD}/::mount \"mv ${CD}-unmounted ${CD}\"; | |
957 | acquire::cdrom::${CD}/::umount \"mv ${CD} ${CD}-unmounted\"; | |
958 | acquire::cdrom::autodetect 0;" > rootdir/etc/apt/apt.conf.d/00cdrom | |
959 | echo -n "$1" > ${CD}/.disk/info | |
960 | if [ ! -d aptarchive/dists ]; then | |
961 | msgdie 'Flat file archive cdroms can not be created currently' | |
962 | return 1 | |
963 | fi | |
964 | mv aptarchive/dists "$CD" | |
965 | ln -s "$(readlink -f ./incoming)" $CD/pool | |
966 | find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list' -delete | |
967 | # start with an unmounted disk | |
968 | mv "${CD}" "${CD}-unmounted" | |
969 | # we don't want the disk to be modifiable | |
970 | addtrap 'prefix' "chmod -f -R +w $PWD/rootdir/media/cdrom/dists/ $PWD/rootdir/media/cdrom-unmounted/dists/ || true;" | |
971 | chmod -R -w rootdir/media/cdrom-unmounted/dists | |
972 | } | |
973 | ||
974 | downloadfile() { | |
975 | local PROTO="$(echo "$1" | cut -d':' -f 1 )" | |
976 | apthelper -o Debug::Acquire::${PROTO}=1 \ | |
977 | download-file "$1" "$2" 2>&1 || true | |
978 | # only if the file exists the download was successful | |
979 | if [ -e "$2" ]; then | |
980 | return 0 | |
981 | else | |
982 | return 1 | |
983 | fi | |
984 | } | |
985 | ||
986 | checkdiff() { | |
987 | local DIFFTEXT="$(command diff -u "$@" | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')" | |
988 | if [ -n "$DIFFTEXT" ]; then | |
989 | echo >&2 | |
990 | echo >&2 "$DIFFTEXT" | |
991 | return 1 | |
992 | else | |
993 | return 0 | |
994 | fi | |
995 | } | |
996 | ||
997 | testfileequal() { | |
998 | local FILE="$1" | |
999 | shift | |
1000 | msgtest "Test for correctness of file" "$FILE" | |
1001 | if [ -z "$*" ]; then | |
1002 | echo -n "" | checkdiff $FILE - && msgpass || msgfail | |
1003 | else | |
1004 | echo "$*" | checkdiff $FILE - && msgpass || msgfail | |
1005 | fi | |
1006 | } | |
1007 | ||
1008 | testempty() { | |
1009 | msgtest "Test for no output of" "$*" | |
1010 | test -z "$($* 2>&1)" && msgpass || msgfail | |
1011 | } | |
1012 | ||
1013 | testequal() { | |
1014 | local MSG='Test of equality of' | |
1015 | if [ "$1" = '--nomsg' ]; then | |
1016 | MSG='' | |
1017 | shift | |
1018 | fi | |
1019 | ||
1020 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequal.comparefile" | |
1021 | echo "$1" > $COMPAREFILE | |
1022 | shift | |
1023 | ||
1024 | if [ -n "$MSG" ]; then | |
1025 | msgtest "$MSG" "$*" | |
1026 | fi | |
1027 | $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail | |
1028 | } | |
1029 | ||
1030 | testequalor2() { | |
1031 | local COMPAREFILE1="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile1" | |
1032 | local COMPAREFILE2="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.comparefile2" | |
1033 | local COMPAREAGAINST="${TMPWORKINGDIRECTORY}/rootdir/tmp/testequalor2.compareagainst" | |
1034 | echo "$1" > $COMPAREFILE1 | |
1035 | echo "$2" > $COMPAREFILE2 | |
1036 | shift 2 | |
1037 | msgtest "Test for equality OR of" "$*" | |
1038 | $* >$COMPAREAGAINST 2>&1 || true | |
1039 | if checkdiff $COMPAREFILE1 $COMPAREAGAINST >/dev/null 2>&1 || \ | |
1040 | checkdiff $COMPAREFILE2 $COMPAREAGAINST >/dev/null 2>&1 | |
1041 | then | |
1042 | msgpass | |
1043 | else | |
1044 | echo -n "\n${CINFO}Diff against OR 1${CNORMAL}" | |
1045 | checkdiff $COMPAREFILE1 $COMPAREAGAINST || true | |
1046 | echo -n "${CINFO}Diff against OR 2${CNORMAL}" | |
1047 | checkdiff $COMPAREFILE2 $COMPAREAGAINST || true | |
1048 | msgfail | |
1049 | fi | |
1050 | } | |
1051 | ||
1052 | testshowvirtual() { | |
1053 | local VIRTUAL="N: Can't select versions from package '$1' as it is purely virtual" | |
1054 | local PACKAGE="$1" | |
1055 | shift | |
1056 | while [ -n "$1" ]; do | |
1057 | VIRTUAL="${VIRTUAL} | |
1058 | N: Can't select versions from package '$1' as it is purely virtual" | |
1059 | PACKAGE="${PACKAGE} $1" | |
1060 | shift | |
1061 | done | |
1062 | msgtest "Test for virtual packages" "apt-cache show $PACKAGE" | |
1063 | VIRTUAL="${VIRTUAL} | |
1064 | N: No packages found" | |
1065 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testshowvirtual.comparefile" | |
1066 | local ARCH="$(getarchitecture 'native')" | |
1067 | echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE | |
1068 | aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail | |
1069 | } | |
1070 | ||
1071 | testnopackage() { | |
1072 | msgtest "Test for non-existent packages" "apt-cache show $*" | |
1073 | local SHOWPKG="$(aptcache show "$@" 2>&1 | grep '^Package: ')" | |
1074 | if [ -n "$SHOWPKG" ]; then | |
1075 | echo >&2 | |
1076 | echo >&2 "$SHOWPKG" | |
1077 | msgfail | |
1078 | else | |
1079 | msgpass | |
1080 | fi | |
1081 | } | |
1082 | ||
1083 | testdpkginstalled() { | |
1084 | msgtest "Test for correctly installed package(s) with" "dpkg -l $*" | |
1085 | local PKGS="$(dpkg -l "$@" 2>/dev/null | grep '^i' | wc -l)" | |
1086 | if [ "$PKGS" != $# ]; then | |
1087 | echo >&2 $PKGS | |
1088 | dpkg -l "$@" | grep '^[a-z]' >&2 | |
1089 | msgfail | |
1090 | else | |
1091 | msgpass | |
1092 | fi | |
1093 | } | |
1094 | ||
1095 | testdpkgnotinstalled() { | |
1096 | msgtest "Test for correctly not-installed package(s) with" "dpkg -l $*" | |
1097 | local PKGS="$(dpkg -l "$@" 2> /dev/null | grep '^i' | wc -l)" | |
1098 | if [ "$PKGS" != 0 ]; then | |
1099 | echo | |
1100 | dpkg -l "$@" | grep '^[a-z]' >&2 | |
1101 | msgfail | |
1102 | else | |
1103 | msgpass | |
1104 | fi | |
1105 | } | |
1106 | ||
1107 | testmarkedauto() { | |
1108 | local COMPAREFILE="${TMPWORKINGDIRECTORY}/rootdir/tmp/testmarkedauto.comparefile" | |
1109 | if [ -n "$1" ]; then | |
1110 | msgtest 'Test for correctly marked as auto-installed' "$*" | |
1111 | while [ -n "$1" ]; do echo "$1"; shift; done | sort > $COMPAREFILE | |
1112 | else | |
1113 | msgtest 'Test for correctly marked as auto-installed' 'no package' | |
1114 | echo -n > $COMPAREFILE | |
1115 | fi | |
1116 | aptmark showauto 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail | |
1117 | } | |
1118 | ||
1119 | testsuccess() { | |
1120 | if [ "$1" = '--nomsg' ]; then | |
1121 | shift | |
1122 | else | |
1123 | msgtest 'Test for successful execution of' "$*" | |
1124 | fi | |
1125 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testsuccess.output" | |
1126 | if $@ >${OUTPUT} 2>&1; then | |
1127 | msgpass | |
1128 | else | |
1129 | echo >&2 | |
1130 | cat >&2 $OUTPUT | |
1131 | msgfail | |
1132 | fi | |
1133 | } | |
1134 | ||
1135 | testfailure() { | |
1136 | if [ "$1" = '--nomsg' ]; then | |
1137 | shift | |
1138 | else | |
1139 | msgtest 'Test for failure in execution of' "$*" | |
1140 | fi | |
1141 | local OUTPUT="${TMPWORKINGDIRECTORY}/rootdir/tmp/testfailure.output" | |
1142 | if $@ >${OUTPUT} 2>&1; then | |
1143 | echo >&2 | |
1144 | cat >&2 $OUTPUT | |
1145 | msgfail | |
1146 | else | |
1147 | msgpass | |
1148 | fi | |
1149 | } | |
1150 | ||
1151 | testwebserverlaststatuscode() { | |
1152 | local DOWNLOG='rootdir/tmp/webserverstatus-testfile.log' | |
1153 | local STATUS='rootdir/tmp/webserverstatus-statusfile.log' | |
1154 | rm -f "$DOWNLOG" "$STATUS" | |
1155 | msgtest 'Test last status code from the webserver was' "$1" | |
1156 | downloadfile "http://localhost:8080/_config/find/aptwebserver::last-status-code" "$STATUS" > "$DOWNLOG" | |
1157 | if [ "$(cat "$STATUS")" = "$1" ]; then | |
1158 | msgpass | |
1159 | else | |
1160 | echo >&2 | |
1161 | if [ -n "$2" ]; then | |
1162 | shift | |
1163 | echo >&2 '#### Additionally provided output files contain:' | |
1164 | cat >&2 "$@" | |
1165 | fi | |
1166 | echo >&2 '#### Download log of the status code:' | |
1167 | cat >&2 "$DOWNLOG" | |
1168 | msgfail "Status was $(cat "$STATUS")" | |
1169 | fi | |
1170 | } | |
1171 | ||
1172 | pause() { | |
1173 | echo "STOPPED execution. Press enter to continue" | |
1174 | local IGNORE | |
1175 | read IGNORE | |
1176 | } |